package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
/**
 * @author lhh
 * @description:危险行为态度量表
 * @date 2021/11/04 15:55
 */
public class SRBAScale extends BaseScale {
    public SRBAScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }
    public JSONObject scaleCalculate() throws Exception{

        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();
        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        if (dimensionEntities.size() > 0){
            //计算每个维度得分
            System.out.println(">>>>>>>>>>>>"+dimensionEntities.size());
            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question:questionNo){
                        if (question.equals(jsonObject1.getString("questionNo"))){
                            for (AnswerEntity answerEntity:answerEntities){
                                ///只用比较选项内容，进而判定该题目的分数值
                                if (answerEntity.getQuestionNo().equals(question) &&answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                    dimensionScore[y] += Double.valueOf(answerEntity.getScore());
                                }
                            }
                            break;
                        }
                    }
                }

            }
            //计算每个维度的平均分
            DecimalFormat df = new DecimalFormat("######0.00");
            double[] Mdscore = new double[dimensionScore.length];
            Mdscore[0]= Double.parseDouble(df.format(dimensionScore[0]/8.0));
            Mdscore[1]= Double.parseDouble(df.format(dimensionScore[1]/5.0));
               Mdscore[2]= Double.parseDouble(df.format(dimensionScore[2]/5.0));


            resultMap0.put("对自身违反速度条例的态度维度均分", String.valueOf(Mdscore[0]));
            resultMap0.put("对他人粗心驾驶的态度维度均分", String.valueOf(Mdscore[1]));
              resultMap0.put("对酒后驾驶的态度维度均分", String.valueOf(Mdscore[2]));
            resultMap0.put("均分解释：", "维度得分越高，代表驾驶员越赞同该维度所测量的危险驾驶行为。");

            resultJson.put("对自身违反速度条例的态度维度均分", String.valueOf(Mdscore[0]));
            resultJson.put("对他人粗心驾驶的态度维度均分", String.valueOf(Mdscore[1]));
            resultJson.put("对酒后驾驶的态度维度均分", String.valueOf(Mdscore[2]));
            resultJson.put("均分解释：", "维度得分越高，代表驾驶员越赞同该维度所测量的危险驾驶行为。");


            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;

    }




}
